=== debian/changelog ===
opentoonz-dmo (1.7.1-dmo1) unstable; urgency=medium

  * New upstream bugfix release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 10 May 2023 07:28:53 +0200

opentoonz-dmo (1.7.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 09 May 2023 08:44:44 +0200

opentoonz-dmo (1.6.0-dmo3) unstable; urgency=medium

  * Build with libglut3.12

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 06 Nov 2022 08:01:56 +0100

opentoonz-dmo (1.6.0-dmo2) unstable; urgency=medium

  * Build with opencv 4.6.0

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 02 Jul 2022 07:10:42 +0200

opentoonz-dmo (1.6.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Fri, 01 Apr 2022 08:30:51 +0200

opentoonz-dmo (1.5.0-dmo3) unstable; urgency=medium

  * Build with opencv 4.5d

 -- Christian Marillat <marillat@deb-multimedia.org>  Fri, 26 Nov 2021 09:22:50 +0100

opentoonz-dmo (1.5.0-dmo2) unstable; urgency=medium

  * Build with libglew2.2

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 29 Sep 2021 23:51:29 +0200
